//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  TEditŁCPaint\bhƓ@\̃\bh@
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2014N1218 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TMyEdit = class(TEdit)
  private
    FCanvas : TCanvas;
  protected
    procedure Paint; virtual;
    procedure WMPaint(var Message: TWMPaint); message WM_PAINT;
    procedure PaintWindow(DC: HDC); override;
    property Canvas: TCanvas read FCanvas;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure DefaultHandler(var Message); override;
  end;

  TForm1 = class(TForm)
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
  private
    { Private 錾 }
    MyEdit : TMyEdit;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

//=============================================================================
//  tH[̏
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
begin
  MyEdit := TMyEdit.Create(Self);
  MyEdit.Parent    := Self;
  MyEdit.AutoSize  := False;
  MyEdit.Left      := Button1.Left;
  MyEdit.Top       := Button1.Top + Button1.Height + 10;
  MyEdit.Height    := 100;
  MyEdit.Width     := 250;
  MyEdit.Font.Size := 20;

  ActiveControl := MyEdit;
end;

{ TMyEdit }

//-----------------------------------------------------------------------------
//  RXgN^
//  `pTCanvas𐶐
//-----------------------------------------------------------------------------
constructor TMyEdit.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);

  FCanvas := TControlCanvas.Create;
  TControlCanvas(FCanvas).Control := Self;
end;

//-----------------------------------------------------------------------------
//  Destroy
//-----------------------------------------------------------------------------
destructor TMyEdit.Destroy;
begin
  FCanvas.Free;
  inherited Destroy;
end;

//-----------------------------------------------------------------------------
//   WM_PAINTbZ[W
//   ̃bZ[W̏Paint\bh̎\ɂȂ
//-----------------------------------------------------------------------------
procedure TMyEdit.WMPaint(var Message: TWMPaint);
begin
  ControlState := ControlState + [csCustomPaint];
  inherited;
  ControlState := ControlState - [csCustomPaint];
end;

//-----------------------------------------------------------------------------
//  PaintWindow\bh
//  TCanvasfoCXReLXgɌԕtĂ
//-----------------------------------------------------------------------------
procedure TMyEdit.PaintWindow(DC: HDC);
begin
  FCanvas.Lock;
  try
   FCanvas.Handle := DC;
   try
     TControlCanvas(FCanvas).UpdateTextFlags;
     Paint;
   finally
     FCanvas.Handle := 0;
   end;
  finally
   FCanvas.Unlock;
  end;
end;

//-----------------------------------------------------------------------------
//  e탁bZ[W̉p
//  ȉ̃R[h̏ȂƁCtH[JXȂ`sĂ܂
//-----------------------------------------------------------------------------
procedure TMyEdit.DefaultHandler(var Message);
begin
  inherited;

  case TMessage(Message).Msg of
    WM_LBUTTONDOWN,
    WM_NCLBUTTONDOWN,
    WM_MBUTTONDOWN,
    WM_NCMBUTTONDOWN,
    WM_RBUTTONDOWN,
    WM_NCRBUTTONDOWN:
    begin
      if not (csDesigning in ComponentState) and not Focused then begin
        Windows.SetFocus(Handle);
      end;
    end;
  end;
end;

//-----------------------------------------------------------------------------
//  Paint\bh
//-----------------------------------------------------------------------------
procedure TMyEdit.Paint;
var
  LRect    : TRect;
  LBitmap  : TBitmap;
  LImgFile : String;
  LFlags   : Cardinal;
begin
  inherited;

  LRect  := ClientRect;
  FCanvas.FillRect(LRect);
  FCanvas.Brush.Assign(Self.Brush);
  FCanvas.Font.Assign(Self.Font);

  LBitmap := TBitmap.Create;
  try
    LImgFile := 'kobito_b.bmp';
    if FileExists(LImgFile) then begin
      LBitmap.LoadFromFile(LImgFile);
      FCanvas.StretchDraw(FCanvas.ClipRect, LBitmap);
    end;
  finally
    FreeAndNil(LBitmap);
  end;

  FCanvas.Brush.Style := bsClear;

  LFlags := DT_SINGLELINE or DT_LEFT or DT_NOPREFIX;
  DrawText(FCanvas.Handle, PChar(Text), -1, LRect, LFlags);
end;

end.
