unit SaNumEditExB;

//----------------------------------------------------------------------
// TSaNumEditExBF TSaNumEdit Ver1.40phR|[lg
//----------------------------------------------------------------------
// ELƃ}CiX̐FwǉĂ܂B
//   LeftMarkColor FL̐Fw
//   RightMarkColorFEL̐Fw
//   MinusColor    F}CiX̐Fw
// iӁj
//     li}CiXȊOj̐FFont.ColorŎw肵ĂB
//----------------------------------------------------------------------
// ij
//     PaintI[o[Ch邱ƂŁAƎ`Ă܂B
//----------------------------------------------------------------------
// iCXg[̒Ӂj
// ̃R|[lgCXg[OTSaNumEdit Ver1.40
// CXg[ĂĂB
//----------------------------------------------------------------------

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,
  SaNumEdit;

type
  TSaNumEditExB = class(TSaNumEdit)
  private
    { Private 錾 }
    FLeftMarkColor: TColor;   // L̐Fw
    FRightMarkColor: TColor;  // EL̐Fw
    FMinusColor: TColor;      // }CiXl̐Fw
  protected
    { Protected 錾 }
    procedure Paint; override;
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
  published
    { Published 錾 }
    property LeftMarkColor: TColor read FLeftMarkColor write FLeftMarkColor;
    property RightMarkColor: TColor read FRightMarkColor write FRightMarkColor;
    property MinusColor: TColor read FMinusColor write FMinusColor default clRed;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('SaCompo', [TSaNumEditExB]);
end;

//----------------------------------------------------------------------
(* RXgN^ *)
constructor TSaNumEditExB.Create(AOwner : TComponent);
begin
  Inherited Create(AOwner);
  FMinusColor := clRed;
  FLeftMarkColor := Font.Color;
  FRightMarkColor := Font.Color;
end;

//----------------------------------------------------------------------
(* `I[o[Ch *)
procedure TSaNumEditExB.Paint;
var
  DrawRect, LMRect, RMRect, wRect: TRect;
  bkgColor, txtColor: TColor;
  swork: string;
begin
  //inherited;

  LMRect   := GetLeftMarkRect;
  DrawRect := GetValueTextRect;
  RMRect   := GetRightMarkRect;
  wRect := DrawRect;
  if LeftMark <> '' then
    wRect.Left  := LMRect.Left;
  if RightMark <> '' then
    wRect.Right := RMRect.Right;

  swork := CreateDrawString2(Text);

  // wi`
  if SelLength = 0 then
  begin
    // IĂȂ
    bkgColor := Color;
  end
  else
  begin
    // IĂ
    bkgColor := clHighlight;
  end;

  if Enabled = False then
  begin
    bkgColor := Color;
  end;

  Canvas.Brush.Color := bkgColor;

  Canvas.FillRect(wRect);

  Canvas.Brush.Style := bsClear;

  // L`悷
  if SelLength = 0 then
  begin
    // IĂȂ
    txtColor := FLeftMarkColor;
  end
  else
  begin
    // IĂ
    txtColor := clHighlightText;
  end;

  if Enabled = False then
  begin
    txtColor := DisabledColor;
  end;

  Canvas.Font.Color := txtColor;
  if (LeftMark <> '') and (swork <> '')  then
    DrawText(Canvas.Handle, PChar(LeftMark), -1, LMRect, DT_SINGLELINE or DT_LEFT );

  // l`悷
  if SelLength = 0 then
  begin
    // IĂȂ
    txtColor := Font.Color;
    if AnsiPos('-', swork) <> 0 then
      txtColor := FMinusColor;  // }CiXl̏ꍇ
  end
  else
  begin
    // IĂ
    txtColor := clHighlightText;
  end;

  if Enabled = False then
  begin
    txtColor := DisabledColor;
  end;
  Canvas.Font.Color := txtColor;

  DrawText(Canvas.Handle, PChar(swork), -1, DrawRect, DT_SINGLELINE or DT_LEFT );

  // EL`悷
  if SelLength = 0 then
  begin
    // IĂȂ
    txtColor := FRightMarkColor;
  end
  else
  begin
    // IĂ
    txtColor := clHighlightText;
  end;

  if Enabled = False then
  begin
    txtColor := DisabledColor;
  end;
  Canvas.Font.Color := txtColor;

  if (RightMark <> '') and (swork <> '')  then
    DrawText(Canvas.Handle, PChar(RightMark), -1, RMRect, DT_SINGLELINE or DT_LEFT );
end;

end.
