//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  TplEditR|[lǧpR|[lg̍쐬
//  l̓͐pR|[lg
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2014N1120 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit plIntegerEdit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Controls, plEdit;

type
  TplIntegerEdit = class(TplEdit)
  private
    procedure SetIntValue(const Value: Integer);
    function GetIntValue: Integer;
  protected
    procedure Change; override;
  public
    constructor Create(AOwner: TComponent); override;
    property IntValue : Integer read GetIntValue write SetIntValue;
  end;

procedure Register;

implementation

{ TplIntegerEdit }

//-----------------------------------------------------------------------------
//  l͐pGfBbgR|[lgCreate\bh
//-----------------------------------------------------------------------------
constructor TplIntegerEdit.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  text          := '';
  Alignment     := taRightJustify;
  VertAlignment := tvaCenter;
  PermitChars   := ['0'..'9', ',', '-'];
end;

//-----------------------------------------------------------------------------
//  IntValuevpeB̐ݒp\bh
//-----------------------------------------------------------------------------
procedure TplIntegerEdit.SetIntValue(const Value: Integer);
begin
  if Value > 0 then begin
    Text := IntToStr(Value);
  end;
end;

//-----------------------------------------------------------------------------
//  IntValuevpeB̎擾p\bh
//-----------------------------------------------------------------------------
function TplIntegerEdit.GetIntValue: Integer;
var
  TheText : String;
begin
  TheText  := StringReplace(Text, ',', '', [rfReplaceAll]);
  if TheText = '' then begin
    Result := 0;
  end else begin
    Result := StrToInt(TheText);
  end;
end;

//-----------------------------------------------------------------------------
//  Change\bh
//  TextvpeB̒lςƎIɎs郁\bh
//  x̓_CAOł͂ȂCqgEBhE̕mȂ
//-----------------------------------------------------------------------------
procedure TplIntegerEdit.Change;
var
  TheText  : String;
  SetText  : String;
  CaretPos : Integer;
  LValue   : Integer;
begin
  inherited;

  if Text = '' then begin
    PermitChars := ['0'..'9', '-'];
  end else
  if Text = '-' then begin
    PermitChars := ['0'..'9', ','];
  end else begin
    CaretPos    := SelStart;
    PermitChars := ['0'..'9', ','];
    TheText     := StringReplace(Text, ',', '', [rfReplaceAll]);

    if ((TheText[1] = '-') and (Length(TheText) > 11))
      or ((TheText[1] <> '-') and (Length(TheText) > 10)) then begin
      TheText := Copy(TheText, 1, Length(TheText) - 1);
      MessageBox(Handle, '10 ȏ͓͕sD', 'I[o', MB_ICONINFORMATION);
    end;
    try
      LValue  := StrToInt(TheText);
      SetText := FormatFloat('#,##0', LValue);
      if (TheText[1] = '-') and (LValue = 0) then begin
        SetText := '-0';
      end;
      //TextvpeBɒڒlZbgȂ
      //TextvpeBɒڒlƗO
      Perform(WM_SETTEXT, 0, PChar(SetText));
    except
      MessageBox(Handle, 'ɕϊł܂D', '', MB_ICONINFORMATION);
    end;
    if CaretPos >= Length(TheText)  then begin
      SelStart := CaretPos + 1;
    end else begin
      SelStart := CaretPos;
    end;
  end;
end;

//-----------------------------------------------------------------------------
//  R|[lgo^
//-----------------------------------------------------------------------------
procedure Register;
begin
  RegisterComponents('plXRAY', [TplIntegerEdit]);
end;

end.

