unit D5Unit1;

//----------------------------------------------------------------------
// TSaNumEdit  SaNumEditR|[lgTvvO
//   Version 1.40  1999.11.11
//----------------------------------------------------------------------

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, SaNumEdit;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    PageControl1: TPageControl;
    Button1: TButton;
    Button2: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Edit1: TEdit;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    Label3: TLabel;
    ComboBox1: TComboBox;
    Button3: TButton;
    Panel2: TPanel;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    Button4: TButton;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    Label4: TLabel;
    Edit2: TEdit;
    CheckBox7: TCheckBox;
    TabSheet4: TTabSheet;
    Label5: TLabel;
    Edit3: TEdit;
    Label6: TLabel;
    Edit4: TEdit;
    CheckBox8: TCheckBox;
    Label7: TLabel;
    Edit5: TEdit;
    Label8: TLabel;
    Edit6: TEdit;
    CheckBox9: TCheckBox;
    CheckBox10: TCheckBox;
    CheckBox11: TCheckBox;
    Label9: TLabel;
    Edit7: TEdit;
    Label10: TLabel;
    Edit8: TEdit;
    Label11: TLabel;
    Edit9: TEdit;
    Label12: TLabel;
    Edit10: TEdit;
    Label13: TLabel;
    ComboBox2: TComboBox;
    Label14: TLabel;
    ComboBox3: TComboBox;
    Label15: TLabel;
    Edit11: TEdit;
    Label16: TLabel;
    Edit12: TEdit;
    CheckBox12: TCheckBox;
    CheckBox13: TCheckBox;
    CheckBox14: TCheckBox;
    CheckBox15: TCheckBox;
    Button5: TButton;
    Panel3: TPanel;
    GroupBox1: TGroupBox;
    CheckBox16: TCheckBox;
    CheckBox17: TCheckBox;
    CheckBox18: TCheckBox;
    CheckBox19: TCheckBox;
    CheckBox20: TCheckBox;
    Panel4: TPanel;
    ColorDialog1: TColorDialog;
    ColorDialog2: TColorDialog;
    FontDialog1: TFontDialog;
    Button6: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
    SaNumEdit1: TSaNumEdit;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  // tH[쐬

  // TSaNumEdit I
  SaNumEdit1 := Nil;
  SaNumEdit1 := TSaNumEdit.Create(Self);
  SaNumEdit1.Parent := Panel1;
  SaNumEdit1.Top := Edit1.Top;
  SaNumEdit1.Left := Label1.Left + (Edit2.Left - Label2.Left);
  SaNumEdit1.TabOrder := 0;  // ŏɃtH[JX悤ɂ

  // Panel 
  Panel1.Caption := '';
  Panel2.Caption := '';
  Panel3.Caption := '';
  Panel4.Caption := 'Font';

  Panel2.Color := SaNumEdit1.Color;
  Panel3.Color := SaNumEdit1.DisabledColor;
  Panel4.Font.Assign(SaNumEdit1.Font);

  // Edit 
  Edit1.Text  := '';
  Edit2.Text  := SaNumEdit1.Text;
  Edit3.Text  := IntToStr(SaNumEdit1.Height);
  Edit4.Text  := IntToStr(SaNumEdit1.Width);
  Edit5.Text  := IntToStr(SaNumEdit1.IntegerLength);
  Edit6.Text  := IntToStr(SaNumEdit1.DecimalLength);
  Edit7.Text  := IntToStr(SaNumEdit1.TopMargin);
  Edit8.Text  := IntToStr(SaNumEdit1.LeftMargin);
  Edit9.Text  := IntToStr(SaNumEdit1.BottomMargin);
  Edit10.Text := IntToStr(SaNumEdit1.RightMargin);
  Edit11.Text := SaNumEdit1.LeftMark;
  Edit12.Text := SaNumEdit1.RightMark;

  // ComboBox 
  ComboBox1.Items.Clear;
  ComboBox1.Items.Add('bsNone');
  ComboBox1.Items.Add('bsSingle');

  ComboBox2.Items.Clear;
  ComboBox2.Items.Add('taLeftJustify');
  ComboBox2.Items.Add('taRightJustify');
  ComboBox2.Items.Add('taCenter');

  ComboBox3.Items.Clear;
  ComboBox3.Items.Add('taTopJustify');
  ComboBox3.Items.Add('taBottomJustify');
  ComboBox3.Items.Add('taVCenter');

  if SaNumEdit1.BorderStyle = bsNone then
    ComboBox1.ItemIndex := 0
  else
    ComboBox1.ItemIndex := 1;

  if SaNumEdit1.Alignment = taLeftJustify then
    ComboBox2.ItemIndex := 0;
  if SaNumEdit1.Alignment = taRightJustify then
    ComboBox2.ItemIndex := 1;
  if SaNumEdit1.Alignment = taCenter then
    ComboBox2.ItemIndex := 2;

  if SaNumEdit1.VertAlignment = taTopJustify then
    ComboBox3.ItemIndex := 0;
  if SaNumEdit1.VertAlignment = taBottomJustify then
    ComboBox3.ItemIndex := 1;
  if SaNumEdit1.VertAlignment = taVCenter then
    ComboBox3.ItemIndex := 2;

  // CheckBox 
  CheckBox1.Checked  := SaNumEdit1.AutoSelect;
  CheckBox2.Checked  := SaNumEdit1.AutoSize;
  CheckBox3.Checked  := SaNumEdit1.Ctl3D;
  CheckBox4.Checked  := SaNumEdit1.Enabled;
  CheckBox5.Checked  := SaNumEdit1.HideSelection;
  CheckBox6.Checked  := SaNumEdit1.ReadOnly;
  CheckBox7.Checked  := SaNumEdit1.Visible;
  CheckBox8.Checked  := SaNumEdit1.Minus;
  CheckBox9.Checked  := SaNumEdit1.Comma;
  CheckBox10.Checked := SaNumEdit1.IntegerFixed;
  CheckBox11.Checked := SaNumEdit1.DecimalFixed;
  CheckBox12.Checked := SaNumEdit1.ArrowFocusMove;
  CheckBox13.Checked := SaNumEdit1.EnterFocusMove;
  CheckBox14.Checked := SaNumEdit1.ErrorBeep;
  CheckBox15.Checked := SaNumEdit1.ImageCopy;
  CheckBox16.Checked := eoMinusOnly in SaNumEdit1.Options;
  CheckBox17.Checked := eoArrowUp in SaNumEdit1.Options;
  CheckBox18.Checked := eoArrowDown in SaNumEdit1.Options;
  CheckBox19.Checked := eoAutoWidthSize in SaNumEdit1.Options;
  CheckBox20.Checked := eoORInputStop in SaNumEdit1.Options;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  // Kp

  //// TSaNumEdit
  // Panel ̐ݒ𔽉f
  SaNumEdit1.Color         := Panel2.Color;
  SaNumEdit1.DisabledColor := Panel3.Color;
  SaNumEdit1.Font.Assign(Panel4.Font);

  // Edit ̐ݒ𔽉f
  SaNumEdit1.Height := StrToIntDef(Edit3.Text, Edit3.Height);
  Edit3.Text  := IntToStr(SaNumEdit1.Height);

  SaNumEdit1.Width  := StrToIntDef(Edit4.Text, Edit3.Width);
  Edit4.Text  := IntToStr(SaNumEdit1.Width);

  SaNumEdit1.IntegerLength := StrToIntDef(Edit5.Text, 9);
  Edit5.Text  := IntToStr(SaNumEdit1.IntegerLength);

  SaNumEdit1.DecimalLength := StrToIntDef(Edit6.Text, 3);
  Edit6.Text  := IntToStr(SaNumEdit1.DecimalLength);

  SaNumEdit1.TopMargin := StrToIntDef(Edit7.Text, 2);
  Edit7.Text  := IntToStr(SaNumEdit1.TopMargin);

  SaNumEdit1.LeftMargin := StrToIntDef(Edit8.Text, 2);
  Edit8.Text  := IntToStr(SaNumEdit1.LeftMargin);

  SaNumEdit1.BottomMargin := StrToIntDef(Edit9.Text, 2);
  Edit9.Text  := IntToStr(SaNumEdit1.BottomMargin);

  SaNumEdit1.RightMargin := StrToIntDef(Edit10.Text, 2);
  Edit10.Text := IntToStr(SaNumEdit1.RightMargin);

  SaNumEdit1.LeftMark  := Edit11.Text;
  SaNumEdit1.RightMark := Edit12.Text;

  // ComboBox ̐ݒ𔽉f
  Case ComboBox1.ItemIndex of
    0: SaNumEdit1.BorderStyle := bsNone;
    1: SaNumEdit1.BorderStyle := bsSingle;
  end;

  Case ComboBox2.ItemIndex of
    0: SaNumEdit1.Alignment := taLeftJustify;
    1: SaNumEdit1.Alignment := taRightJustify;
    2: SaNumEdit1.Alignment := taCenter;
  end;

  Case ComboBox3.ItemIndex of
    0: SaNumEdit1.VertAlignment := taTopJustify;
    1: SaNumEdit1.VertAlignment := taBottomJustify;
    2: SaNumEdit1.VertAlignment := taVCenter;
  end;

  // CheckBox ̐ݒ𔽉f
  SaNumEdit1.AutoSelect     := CheckBox1.Checked;
  SaNumEdit1.AutoSize       := CheckBox2.Checked;
  SaNumEdit1.Ctl3D          := CheckBox3.Checked;
  SaNumEdit1.Enabled        := CheckBox4.Checked;
  SaNumEdit1.HideSelection  := CheckBox5.Checked;
  SaNumEdit1.ReadOnly       := CheckBox6.Checked;
  SaNumEdit1.Visible        := CheckBox7.Checked;
  SaNumEdit1.Minus          := CheckBox8.Checked;
  SaNumEdit1.Comma          := CheckBox9.Checked;
  SaNumEdit1.IntegerFixed   := CheckBox10.Checked;
  SaNumEdit1.DecimalFixed   := CheckBox11.Checked;
  SaNumEdit1.ArrowFocusMove := CheckBox12.Checked;
  SaNumEdit1.EnterFocusMove := CheckBox13.Checked;
  SaNumEdit1.ErrorBeep      := CheckBox14.Checked;
  SaNumEdit1.ImageCopy      := CheckBox15.Checked;

  if CheckBox16.Checked then
    SaNumEdit1.Options := SaNumEdit1.Options + [eoMinusOnly]
  else
    SaNumEdit1.Options := SaNumEdit1.Options - [eoMinusOnly];

  if CheckBox17.Checked then
    SaNumEdit1.Options := SaNumEdit1.Options + [eoArrowUp]
  else
    SaNumEdit1.Options := SaNumEdit1.Options - [eoArrowUp];

  if CheckBox18.Checked then
    SaNumEdit1.Options := SaNumEdit1.Options + [eoArrowDown]
  else
    SaNumEdit1.Options := SaNumEdit1.Options - [eoArrowDown];

  if CheckBox19.Checked then
    SaNumEdit1.Options := SaNumEdit1.Options + [eoAutoWidthSize]
  else
    SaNumEdit1.Options := SaNumEdit1.Options - [eoAutoWidthSize];

  if CheckBox20.Checked then
    SaNumEdit1.Options := SaNumEdit1.Options + [eoORInputStop]
  else
    SaNumEdit1.Options := SaNumEdit1.Options - [eoORInputStop];


  //// TEdit
  // Panel ̐ݒ𔽉f
  Edit1.Color         := Panel2.Color;
  Edit1.Font.Assign(Panel4.Font);

  // Edit 
  Edit1.Height := StrToInt(Edit3.Text);
  Edit1.Width  := StrToInt(Edit4.Text);

  // ComboBox ̐ݒ𔽉f
  Case ComboBox1.ItemIndex of
    0: Edit1.BorderStyle := bsNone;
    1: Edit1.BorderStyle := bsSingle;
  end;

  // CheckBox ̐ݒ𔽉f
  Edit1.AutoSelect    := CheckBox1.Checked;
  Edit1.AutoSize      := CheckBox2.Checked;
  Edit1.Ctl3D         := CheckBox3.Checked;
  Edit1.Enabled       := CheckBox4.Checked;
  Edit1.HideSelection := CheckBox5.Checked;
  Edit1.ReadOnly      := CheckBox6.Checked;
  Edit1.Visible       := CheckBox7.Checked;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  // 
  Close;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  // wiFύX
  ColorDialog1.Color := SaNumEdit1.Color;
  if ColorDialog1.Execute = False then
    Exit;

  Panel2.Color := ColorDialog1.Color;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  // tHgύX
  FontDialog1.Font.Assign(SaNumEdit1.Font);
  if FontDialog1.Execute = False then
    Exit;

  Panel4.Font.Assign(FontDialog1.Font);
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  // 񉞓̕FύX
  ColorDialog2.Color := SaNumEdit1.DisabledColor;
  if ColorDialog2.Execute = False then
    Exit;

  Panel3.Color := ColorDialog2.Color;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  // Editp̓Kp

  SaNumEdit1.Text   := Edit2.Text;
  Edit1.Text   := Edit2.Text;
end;

end.
